using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace entire
{
    public class entire
    {
        public static void Main()
        {
            CategoryBuilder.Create("Geometry Dash Mod", "Play GD on PPG", ModAPI.LoadSprite("Thumb.png"));
            //Default block, a default block.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "normal portal",
                    NameToOrderByOverride = "normal portal",
                    DescriptionOverride = "A normal portal.",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("normal portal.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("defaultblock.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

            //Red block, a blood block.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "spike",
                    NameToOrderByOverride = "spike",
                    DescriptionOverride = "A spike.",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("spike.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("spike.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );


            //Good Red block, a nice color.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "upside portal",
                    NameToOrderByOverride = "upside portal",
                    DescriptionOverride = "A upside portal.",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("upside portal.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("goodredblock.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

            //Leaf block, Leafy is not here sadly.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "spider",
                    NameToOrderByOverride = "spider",
                    DescriptionOverride = "A spider (not a real u stupid).",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("spider.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("spider.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

            // Nice Blue Block.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Nice Blue Block",
                    NameToOrderByOverride = "NiceBlueBlock",
                    DescriptionOverride = "A nice blue block.",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("niceblueblock.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("niceblueblock.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

            // White Block.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "White Block",
                    NameToOrderByOverride = "WhiteBlock",
                    DescriptionOverride = "A white block.",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("whiteblock.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("whiteblock.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

            // Yellow Block.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Default Icon",
                    NameToOrderByOverride = "Default Icon",
                    DescriptionOverride = "A Default Icon.",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("Default Icon.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Default Icon.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

            // Pink Block.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Pink Block",
                    NameToOrderByOverride = "PinkBlock",
                    DescriptionOverride = "A pink blo- wait what?",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("pinkblock.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("pinkblock.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

            // Orange Block.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Robot",
                    NameToOrderByOverride = "Robot",
                    DescriptionOverride = "A Robot.",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("orangeblock.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("orangeblock.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

            // Gray Block.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Gray Block",
                    NameToOrderByOverride = "GrayBlock",
                    DescriptionOverride = "A gray block.",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("grayblock.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("grayblock.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

            // Dark Grey Block.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Dark Grey Block",
                    NameToOrderByOverride = "DarkGreyBlock",
                    DescriptionOverride = "A dark grey block.",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("darkgreyblock.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("darkgreyblock.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

            // Blue Block.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "swingcopter",
                    NameToOrderByOverride = "swingcopter",
                    DescriptionOverride = "A swingcopter.",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("swingcopter.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("swingcopter.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

            // Green Block, WHATS YOUR PROBLEM MAN? GREEN? HELLO GREEN? WHATS YOUR PROBLEM!!!!!!!
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Green Block",
                    NameToOrderByOverride = "GreenBlock",
                    DescriptionOverride = "Whats your problem green?",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("greenblock.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("greenblock.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

            // Dark Green Block.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Monster",
                    NameToOrderByOverride = "Monster",
                    DescriptionOverride = "Whats your problem it's Monster",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("Monster.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Monster.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

            // Brown Block.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "coin",
                    NameToOrderByOverride = "coin",
                    DescriptionOverride = "A coin.",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("brownblock.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("brownblock.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

            // Purple Block.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Purple Block",
                    NameToOrderByOverride = "PurpleBlock",
                    DescriptionOverride = "A purple block.",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("purpleblock.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("purpleblock.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

            // Wood Block.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "orb",
                    NameToOrderByOverride = "orb",
                    DescriptionOverride = "An orb",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("orb.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("woodblock.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );

 ModAPI.Register(
			new Modification()
			{
				OriginalItem = ModAPI.FindSpawnable("Pistol"),
				NameOverride = "Dash",
				DescriptionOverride = "**Disable Collision before using**",
				CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
				ThumbnailOverride = ModAPI.LoadSprite("ins.png"),
                               NameToOrderByOverride = "a",
				AfterSpawn = (Instance) =>
					{

				      	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ins.png", 1f);
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						Cartridge customCartridge = ModAPI.FindCartridge("9mm");
						customCartridge.name = "BCMusic";
						firearm.Cartridge = customCartridge;
						customCartridge.Damage = 0f; //change the damage however you like
						customCartridge.StartSpeed *= 0f; //change the bullet velocity
						customCartridge.PenetrationRandomAngleMultiplier *= 0f; //change the accuracy when the bullet travels through an object
						customCartridge.Recoil *= 0f; //change the recoil
						customCartridge.ImpactForce *= 0f; //change how much the bullet pushes the target
						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("MDK - GEOMETRY DASH  Sneak Peek 2.2 Full song [EXTENDED] (1).mp3"),
						};
						Instance.FixColliders();


					}
				}
			);


             ModAPI.Register(
			new Modification()
			{
				OriginalItem = ModAPI.FindSpawnable("Pistol"),
				NameOverride = "StereoMadness",
				DescriptionOverride = "**Disable Collision before using**",
				CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
				ThumbnailOverride = ModAPI.LoadSprite("ez.png"),
                               NameToOrderByOverride = "a",
				AfterSpawn = (Instance) =>
					{

				      	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("ez.png", 1f);
						var firearm = Instance.GetComponent<FirearmBehaviour>();
						Cartridge customCartridge = ModAPI.FindCartridge("9mm");
						customCartridge.name = "BCMusic";
						firearm.Cartridge = customCartridge;
						customCartridge.Damage = 0f; //change the damage however you like
						customCartridge.StartSpeed *= 0f; //change the bullet velocity
						customCartridge.PenetrationRandomAngleMultiplier *= 0f; //change the accuracy when the bullet travels through an object
						customCartridge.Recoil *= 0f; //change the recoil
						customCartridge.ImpactForce *= 0f; //change how much the bullet pushes the target
						firearm.ShotSounds = new AudioClip[]
						{
							ModAPI.LoadSound("StereoMadness.mp3"),
						};
						Instance.FixColliders();


					}
				}
			);


            //Red block, a blood block.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Grid Block",
                    NameToOrderByOverride = "block",
                    DescriptionOverride = "A block.",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("GridBlock05.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("GridBlock05.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );


            //Red block, a blood block.
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "RegularPlatform",
                    NameToOrderByOverride = "block",
                    DescriptionOverride = "A block again.",
                    CategoryOverride = ModAPI.FindCategory("Geometry Dash Mod"),
                    ThumbnailOverride = ModAPI.LoadSprite("RegularPlatform05.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("RegularPlatform05.png", 2f);
                        Instance.FixColliders();
                    }
                }
            );



        }
    }
}